<?php

namespace Example\Example;

use User;

class Example
{
    /**
     * $master_functional_skill object.
     */
    protected $master_functional_skill;

    /**
     * Constructor.
     */
    public function __construct(\Example\Example\Interfaces\MasterFunctionalSkillRepositoryInterface $master_functional_skill)
    {
        $this->master_functional_skill = $master_functional_skill;
    }

    /**
     * Returns count of example.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.master_functional_skill.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->master_functional_skill->pushCriteria(new \Litepie\Example\Repositories\Criteria\MasterFunctionalSkillUserCriteria());
        }

        $master_functional_skill = $this->master_functional_skill->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('example::' . $view, compact('master_functional_skill'))->render();
    }
}
